#ifndef LR0_H
#define LR0_H

#include "parser.h"

typedef enum
  {
    PARSER_SHIFT,
    PARSER_REDUCE,
    PARSER_ACCEPT,
  } action_t;

typedef struct
{
  gint state;
  gpointer attrib;
} state_t;

typedef struct
{
  gint action;
  gint state;
} transition_t;

typedef struct
{
  nextcb cb;
  gpointer data;
  GList* stack;
  GHashTable* table;
  GList* rules;
} lr0_t;

transition_t* transition_new (gint, gint);
lr0_t* lr0_new (nextcb, gpointer);
void lr0_delete (lr0_t*);
void lr0_add (lr0_t*, gint, symbol_t*, transition_t*);
gpointer lr0_build (lr0_t*);

#endif
